<?php
/** 
 *	iCagenda - iC calendar
 *----------------------------------------------------------------------------
 * @package     com_icagenda
 * @copyright	Copyright (C) 2012-2013 JOOMLIC - All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jooml!C - http://www.joomlic.com
 * 
 * @updated		2013-04-08
 * @version		2.1.5
 *----------------------------------------------------------------------------
*/


// No direct access to this file
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.methods' );
jimport( 'joomla.environment.request' );
jimport('joomla.application.component.helper');

// classe du Module
class modiCcalendarHelper
{

	private function construct($params)
	{
		$this->catid = $params->get('mcatid');
		$this->time = $params->get('time');
		$this->number = $params->get('number');
		$page = JRequest::getVar('page', '0', 'get', 'int');
		
		$number=$this->number;
		
		if (!$page){
			$this->start='0';
		}
		if ($page){
			$this->start = $number*($page-1);
		}
		$this->template=$params->get('template');
		$this->format= $params->get('format');
		$this->date_separator= $params->get('date_separator');
				
		//Add Security 
	
		$mItemid = JRequest::getInt('Itemid');
//		if($this->itemid===NULL) $this->itemid = $mItemid;
		$this->itemid = $mItemid;
		
		$this->date_start=date('Y-m-d');
		$dateget=JRequest::getVar('date');
		if(isset($dateget)&&(!empty($dateget))) $this->date_start=$dateget;

		if($this->time==0) $this->addFilter('e.next', $this->date_start,'>=');
		if($this->catid!=0) $this->addFilter('e.catid', $this->catid);
	}

	function start($params)
	{
		$this->construct($params);
	}

	function addFilter($key, $var, $for=NULL){
		if($for==NULL) $for='=';
		$this->filter[$key]=' AND '.$key.$for.$var;
	}
	// Class Method
	function getStamp($params)
	{
		$this->start($params);
		// Prépare la requête
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		
		// Sélection de la requête
		$query->select(
			'e.id, e.title, e.alias, e.params, e.catid, e.image, e.file, e.next, e.dates, e.period, e.time, e.desc, e.address as address, e.place as place_name, e.city as city, e.coordinate as coordinate, c.title as cat_title, c.alias as cat_alias, c.color as cat_color' 
		);
		$query->from('`#__icagenda_events` AS e');
		$query->leftJoin('`#__icagenda_category` AS c ON c.id = e.catid');
		$query->leftJoin('`#__icagenda_events` AS l ON l.id = e.place');
		$query->order('e.next DESC');
		
		// where
		$where='e.state = 1';

		// ajout des filtres
		if(isset($this->filter)){
			foreach ($this->filter as $filter){
				$where.=$filter;
			}
		}

		$query->where($where);
		$query->order('e.next');
		$query.=' LIMIT 0, 1000';
		// requête
		$db->setQuery($query);
		$res = $db->loadObjectList();
		
		$days=$this->getDays($this->date_start, $this->format);
		
		foreach ($res as $r) {
// liste dates calendrier
			if (isset($next)) {$next=$next;} else {$next='';}
			$datemultiplelist=$this->getDatelist($r->dates, $next);
			$dateperiodlist=$this->getPeriodlist($r->period, $next);
			if ($dateperiodlist) {
				$datelist=array_merge($datemultiplelist, $dateperiodlist);
			} else {
				$datelist=$datemultiplelist;
			}

//liste dates next
			$datemlist=$this->getmlist($r->dates, $next);
			$dateplist=$this->getplist($r->period, $next);
			if ($dateplist) {
				$datelistcal=array_merge($datemlist, $dateplist);
			} else {
				$datelistcal=$datemlist;
			}


		$todaytime=time();

			rsort($datelist);
			rsort($datelistcal);
	if ($datelistcal > $todaytime) {
					$alldates=serialize($datelistcal);
	}


		
			
// requête Itemid
 		$lang = JFactory::getLanguage();
		$langcur = $lang->getTag();
		$langcurrent = $langcur;
		
		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS idm')->from('#__menu')->where( "(link = 'index.php?option=com_icagenda&view=list') AND (published > 0) AND (language = '$langcurrent')" );
		$db->setQuery($query);
		$idm=$db->loadResult();
		$mItemid=$idm;
		
		if ($mItemid == NULL) {
		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS noidm')->from('#__menu')->where( "(link = 'index.php?option=com_icagenda&view=list') AND (published > 0) AND (language = '*')" );
		$db->setQuery($query);
		$noidm=$db->loadResult();
		$noidm=$noidm;
		}
		$nolink = '';
		if ($noidm == NULL && $mItemid == NULL) {
			$nolink = 1;
		}			

		$iCmenuitem='';
		$iCmenuitem=$params->get('iCmenuitem');

		if($iCmenuitem == '') {
			if ($mItemid == NULL) {
				$lien = $noidm;
			}
			else {
				$lien = $mItemid;
			}
		} else {
			$lien = $iCmenuitem;
		}
		
		$eventnumber = NULL;
		$eventnumber = $r->id;
		
		if ($nolink == 1) {
			$urlevent = '#';
		}else {
			$urlevent = JRoute::_('index.php?option=com_icagenda&amp;view=list&amp;layout=event&amp;id='.(int)$eventnumber.'&amp;Itemid='.(int)$lien);
		}


		$limit = JComponentHelper::getParams('com_icagenda')->get('ShortDescLimit');
//		$limit=$this->options['limit'];
		$text=strip_tags($r->desc);
		if(strlen($text)>$limit){
			$string_cut=substr($text, 0,$limit);
			$last_space=strrpos($string_cut," ");
			$string_ok=substr($string_cut, 0,$last_space);
			$text=$string_ok." ";
			$text=$text.'[&#46;&#46;&#46;]';
		}else{
			$text=$text;
		}

		$dates=unserialize($r->dates);
		$period=unserialize($r->period);
		if($period != NULL) {$alldates = array_merge($dates, $period);} else {$alldates = $dates;}

		$today=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$toDay=mktime(0,0,0,$m,$day,$y);
		$time='';
		foreach($alldates as $a){
//			$dated=$this->mkt($a);
//			if ($dated == $toDay) {
				foreach ($datelist as $d){
					foreach ($days as $k=>$dy){
						if($d==$dy['date']){
							$dd=$this->mkttime($a);
							$time=date('H:i', $dd);
						}
					}
				}
//			}
		}
//				$d=$this->mkt($a);
//				if ($d == $toDay) {
//						$dd=$this->mkttime($a);
//						$time=date('H:i', $dd);
//			}
//			else {
//				$time='none';
//			}
					
		$event=array(
				'id' => (int)$r->id,
				'Itemid' => (int)$mItemid,
				'url'=> $urlevent,
				'title' => $r->title,
				'image' => $r->image,
// Time under test developpement
//				'time' => $time,
				'address' => $r->address,
				'city' => $r->city,
				'place' => $r->place_name,
				'description' => $r->desc,
				'descShort' => $text,
				'cat_title' => $r->cat_title,
				'cat_color' => $r->cat_color,
				'nb_events' => count($r->id),
				'no_image' => JTEXT::_('MOD_ICCALENDAR_NO_IMAGE'),
			);
		
		
		// Added is_array 1.2.9
		if (is_numeric($lien) && is_numeric($eventnumber) && !is_array($lien) && !is_array($eventnumber)) {
			if (is_array($event)) {
				foreach ($datelist as $d){
					foreach ($days as $k=>$dy){
						if($d==$dy['date']){
							array_push ($days[$k]['events'], $event);
						}
					}
				}
			}
		}
		}
		
		$i='';

 		$lang = JFactory::getLanguage();
		$langcur = $lang->getTag();
		$langcurrent = $langcur;
		
		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS idm')->from('#__menu')->where( "(link = 'index.php?option=com_icagenda&view=list') AND (published > 0) AND (language = '$langcurrent')" );
		$db->setQuery($query);
		$idm=$db->loadResult();
		$mItemid=$idm;
		
		if ($mItemid == NULL) {
		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS noidm')->from('#__menu')->where( "(link = 'index.php?option=com_icagenda&view=list') AND (published > 0) AND (language = '*')" );
		$db->setQuery($query);
		$noidm=$db->loadResult();
		$noidm=$noidm;
		}
		$nolink = '';
		if ($noidm == NULL && $mItemid == NULL) {
			$nolink = 1;
		}			
		if ($nolink == 1) {
			do {
				echo '<div style="color:#a40505; text-align: center;"><b>info :</b></div><div style="color:#a40505; font-size: 0.8em; text-align: center;">'.JText::_( 'MOD_ICCALENDAR_COM_ICAGENDA_MENULINK_UNPUBLISHED_MESSAGE' ).'</div>';
			} while ($i > 0);
  		}			

		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS nbevt')->from('`#__icagenda_events` AS e')->where('e.state > 0');
		$db->setQuery($query);
		$nbevt=$db->loadResult();
		$nbevt=count($nbevt);
		if ($nbevt == NULL) {
//			do {
				echo '<div style="font-size: 0.8em; text-align: center;">'.JText::_( 'MOD_ICCALENDAR_NO_EVENT' ).'</div>';
//			} while ($i = 0);
  		}			
		
		return $days;

	}
	
	// test
	function clickDate ($eventdate, $d)
	{
		$eventdate = $d;
		return $eventdate;
	}

	/***/

	// Function to get Format Date (using option format, and translation)
	protected function formatDate ($d, $for=NULL){

		$format='';
		$separator = ' ';

		if($for==NULL)$for=$this->format;

		//update default value, from 2.0.x to 2.1
		if ($for == '%d.%m.%Y') {$for = 'd m Y'; $separator = '.';}
		if ($for == '%d.%m.%y') {$for = 'd m y'; $separator = '.';}
		if ($for == '%Y.%m.%d') {$for = 'Y m d'; $separator = '.';}
		if ($for == '%Y.%b.%d') {$for = 'Y M d'; $separator = '.';}

		if ($for == '%d-%m-%Y') {$for = 'd m Y'; $separator = '-';}
		if ($for == '%d-%m-%y') {$for = 'd m y'; $separator = '-';}
		if ($for == '%Y-%m-%d') {$for = 'Y m d'; $separator = '-';}
		if ($for == '%Y-%b-%d') {$for = 'Y M d'; $separator = '-';}

		if ($for == '%d/%m/%Y') {$for = 'd m Y'; $separator = '/';}
		if ($for == '%d/%m/%y') {$for = 'd m y'; $separator = '/';}
		if ($for == '%Y/%m/%d') {$for = 'Y m d'; $separator = '/';}
		if ($for == '%Y/%b/%d') {$for = 'Y M d'; $separator = '/';}

		if ($for == '%d %B %Y') {$for = 'd F Y';}
		if ($for == '%d %b %Y') {$for = 'd M Y';}

		if ($for == '%A, %d %B %Y') {$for = 'l, _ d _ Fnosep _ Y';}
		if ($for == '%a %d %b %Y') {$for = 'D _ d _ Mnosep _ Y';}
		if ($for == '%A, %B %d, %Y') {$for = 'l, _ Fnosep _ d, _ Y';}
		if ($for == '%a, %b %d, %Y') {$for = 'D, _ Mnosep _ d, _ Y';}

		$mkt_date=$this->mkt($d);
		$for=str_replace('-', ' ', $for);
		$exformat = explode (' ', $for);

		$dateFormat=date('d-M-Y', $mkt_date);
		if (isset($this->date_separator)) $separator = $this->date_separator;
		foreach($exformat as $k=>$val){
			switch($val){
				// day
				case 'd': $val=strftime("%d", strtotime("$dateFormat")); break;
				case 'd,': $val=strftime("%d", strtotime("$dateFormat")).','; break;
				case 'D': $val=JText::_(strftime("%a", strtotime("$dateFormat"))); break;
				case 'D,': $val=JText::_(strftime("%a", strtotime("$dateFormat"))).','; break;
				case 'j': $val=strftime("%e", strtotime("$dateFormat")); break;
				case 'l': $val=JText::_(strftime("%A", strtotime("$dateFormat"))); break;
				case 'l,': $val=JText::_(strftime("%A", strtotime("$dateFormat"))).','; break;
				case 'N': $val=strftime("%u", strtotime("$dateFormat")); break;
				case 'w': $val=strftime("%w", strtotime("$dateFormat")); break;
				case 'z': $val=strftime("%j", strtotime("$dateFormat")); break;

				// week
				case 'W': $val=strftime("%W", strtotime("$dateFormat")); break;

				// month
				case 'F': $val=$separator.JText::_(strftime("%B", strtotime("$dateFormat"))).$separator; break;
				case 'Fnosep': $val=JText::_(strftime("%B", strtotime("$dateFormat"))); break;
				case 'm': $val=$separator.strftime("%m", strtotime("$dateFormat")).$separator; break;
				case 'msepa': $val=strftime("%m", strtotime("$dateFormat")).$separator; break;
				case 'msepb': $val=$separator.strftime("%m", strtotime("$dateFormat")); break;
				case 'M': $val=$separator.JText::_(strftime("%B", strtotime("$dateFormat")).'_SHORT').$separator; break;
				case 'Mnosep': $val=JText::_(strftime("%B", strtotime("$dateFormat")).'_SHORT'); break;
				case 'n': $val=$separator.strftime("%m", strtotime("$dateFormat")).$separator; break;

				// year
				case 'Y': $val=strftime("%Y", strtotime("$dateFormat")); break;
				case 'y': $val=strftime("%g", strtotime("$dateFormat")); break;

				// time
				case 'H': $val=strftime("%H", strtotime("$dateFormat")); break;
				case 'i': $val=strftime("%i", strtotime("$dateFormat")); break;

				// space
				case '_': $val=' '; break;

				default: $val=''; break;		
			}
			if($k!=0)$format.=''.$val;
			if($k==0)$format.=$val;
		}
		return $format;
	}


	 
	// Génération des jours du mois
	function getDays ($d, $f)
	{

	// Set Locale
//	$codeset = "UTF8";  // warning ! not UTF-8 with dash '-' 
//	$lang = JFactory::getLanguage();
//	$tag = $lang->getTag();
//	$tag=str_replace('-', '_', $tag);
//	$locale = $lang->getlocale() ;
//	setlocale( LC_ALL, $tag.'.'.$codeset, $locale, $locale[0] ) ;

		//update default value, from 1.2.2 to 1.2.3
		if ($f == 'd-m-Y') {
			$f = '%d-%m-%Y';
		}
		
		
		// détermine le mois et l'année

//		$d=str_replace(' ', '-', $d);
//		$d=str_replace(':', '-', $d);
		$ex_data=explode('-', $d);
		$month=$ex_data[1];
		$year=$ex_data[0];
		$jour=$ex_data[2];

		// Génération du Calendrier
		$days = date("d", mktime(0, 0, 0, $month+1, 0, $year));
		$list = array();


//		$today=time();
//		$todayt = date($today, mktime(0, 0, 0, $month+1, 0, $year));
		$day= date('d');
		$m= date('n');
		$y= date('Y');	
				
		for($a=1; $a<=$days; $a++)
		{
         if (($a == $day) && ($month == $m) && ($year == $y)) {
         	$classDay = 'style_Today';
         } else {
         	$classDay = 'style_Day';
         }
			
			$datejour=date('Y-m-d H:i', mktime(0, 0, 0, $month, $a, $year));
			
			$list[$a]['date'] = date('Y-m-d H:i', mktime(0, 0, 0, $month, $a, $year));
			$list[$a]['dateFormat'] = strftime($f, mktime(0, 0, 0, $month, $a, $year));
//			$list[$a]['dateTitle'] =  JText::_(strftime($f, mktime(0, 0, 0, $month, $a, $year)));
//			$list[$a]['dateFormat'] = $this->formatDate($d);
			$list[$a]['dateTitle'] =  $this->formatDate($datejour);
			$list[$a]['week'] = date('N', mktime(0, 0, 0, $month, $a, $year));
			// Removed 'day' in 2.1.2 theme pack, NAME_day.php
			$list[$a]['day'] = "<div class='".$classDay."'>".$a."</div>";
			// Added in 2.1.2 (change in NAME_day.php
			$list[$a]['ifToday'] = $classDay;
			$list[$a]['Days'] = $a;
			//
			$list[$a]['month'] = $month;
			$list[$a]['year'] = $year;
			$list[$a]['events']=array();
//			$list[$a]['plus'] = "$stamp->events[1]['cat_color']";
								
		}
		return $list;
	}
	/***/
	
	/**
	 * liste des dates pour un évènement
	 */
	private function getDatelist($dates, $next)
	{
	
		$dates=unserialize($dates);
		$da=array();
		foreach($dates as $d){
			$d=$this->mkt($d);
			if($d>=$next){
				array_push($da, date('Y-m-d H:i', $d));
			}
		}
		return $da;
	}

	private function getPeriodlist($period, $next)
	{
	
		if ($period) {
			$period=unserialize($period);
			$da=array();
			foreach($period as $d){
				$d=$this->mkt($d);
				if($d>=$next){
					array_push($da, date('Y-m-d H:i', $d));
				}
			}
		} else {
			$da = NULL;
		}
		return $da;
	}

	private function getmlist($dates, $next)
	{
	
		$dates=unserialize($dates);
		$da=array();
		foreach($dates as $d){
			$d=$this->mkttime($d);
			if($d>=$next){
				array_push($da, date('Y-m-d H:i', $d));
			}
		}
		return $da;
	}

	private function getplist($period, $next)
	{
	
		if ($period) {
			$period=unserialize($period);
			$da=array();
			foreach($period as $d){
				$d=$this->mkttime($d);
				if($d>=$next){
					array_push($da, date('Y-m-d H:i', $d));
				}
			}
		} else {
			$da = NULL;
		}
		return $da;
	}

	// Format Date
	private function mkt($data)
	{
		$data=str_replace(' ', '-', $data);
		$data=str_replace(':', '-', $data);
		$ex_data=explode('-', $data);
		$ris=mktime('0', '0', '0', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		return strftime($ris);
	}
	
	private function mkttime($data)
	{
		$data=str_replace(' ', '-', $data);
		$data=str_replace(':', '-', $data);
		$ex_data=explode('-', $data);
		if (isset($ex_data['3'])) {
			$ris=mktime($ex_data['3'], $ex_data['4'], '00', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		} else {
			$ris=mktime('00', '00', '00', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		}
		return strftime($ris);
	}
	
	// 
	private function addDay ($mkt) 
	{
		return $mkt+82800;
	}


	/***/

	/** Systeme de navigation **/
	function getNav($date_start)
	{
		$view='';
		$layout='';
		$Itemid='';
		$id='';
		$option = 'index.php?option='.JRequest::getVar('option');
		if(JRequest::getVar('view'))$view = '&view='.JRequest::getVar('view');
		if(JRequest::getVar('layout'))$layout = '&layout='.JRequest::getVar('layout');
		if(JRequest::getInt('Itemid'))$Itemid = '&Itemid='.JRequest::getInt('Itemid');
		if(JRequest::getInt('id'))$id = '&id='.JRequest::getVar('id');
				$Aurl = $option.$view.$layout.$Itemid.$id;

$Aurl = JURI::current();

		//$data=str_replace(' ', '-', $data);
		//$data=str_replace(':', '-', $data);
		$ex_date=explode('-', $date_start);
		$mkt_date=$this->mkt($date_start);
		$year=$ex_date[0];
		$month=$ex_date[1];
		$day=1;

		if($month!=1){$backMonth=$month-1; $backYear=$year;}
		if($month==1){$backMonth=12; $backYear=$year-1;}
		if($month!=12){$nextMonth=$month+1; $nextYear=$year;}
		if($month==12){$nextMonth=1; $nextYear=$year+1;}
		$backYYear = $year-1;
		$nextYYear = $year+1;

		

		$back='<span class="backic icagendabtn" style="cursor:pointer" href="'.JRoute::_($Aurl.'?date='.$backYear.'-'.$backMonth.'-'.$day).'"><input type="hidden">&nbsp;&#9668;&nbsp;</span>';
		$next='<span class="nextic icagendabtn" style="cursor:pointer" href="'.JRoute::_($Aurl.'?date='.$nextYear.'-'.$nextMonth.'-'.$day).'"><input type="hidden">&nbsp;&#9658;&nbsp;</span>';

		$backY='<span class="backicY icagendabtn" style="cursor:pointer" href="'.JRoute::_($Aurl.'?date='.$backYYear.'-'.$month.'-'.$day).'"><input type="hidden"><small>&nbsp;&#9668;&#9668;&nbsp;</small></span>';
		$nextY='<span class="nexticY icagendabtn" style="cursor:pointer" href="'.JRoute::_($Aurl.'?date='.$nextYYear.'-'.$month.'-'.$day).'"><input type="hidden"><small>&nbsp;&#9658;&#9658;&nbsp;</small></span>';



	/** translate the month in the calendar module -- Leland Vandervort **/
		$dateFormat=date('d-M-Y', $mkt_date);

		// split out the month and year to obtain translation key for JText using joomla core translation
		$t_day = strftime("%d", strtotime("$dateFormat")); 
		$t_month = strftime("%B", strtotime("$dateFormat")); 
		$t_year = strftime("%Y", strtotime("$dateFormat"));

		// now resplice the title back together and call JText::
		$title = JText::_($t_month) . ' ' . $t_year;
		$mois = JText::_($t_month);
		$annee = $t_year;

	/***/

		$html='<div class="icnav">'.$backY.$back.$nextY.$next.'<div class="titleic">'.$title.'</div></div>';
		$html.='<div class="clr"></div>';
//		$html.='<div class="nav">'.$backY.$nextY.'<div class="title" style="text-transform: uppercase;">'.$annee.'</div></div>';
//		$html.='<div class="nav">'.$back.$next.'<div class="title" style="text-transform: uppercase;">'.$mois.'</div></div>';

		return $html;
	}
	/***/


 
}

function activeColor($color){
	#convert hexadecimal to RGB
	if(!is_array($color) && preg_match("/^[#]([0-9a-fA-F]{6})$/",$color)){
		$hex_R = substr($color,1,2);
		$hex_G = substr($color,3,2);
		$hex_B = substr($color,5,2);
		$RGB = hexdec($hex_R).",".hexdec($hex_G).",".hexdec($hex_B);
		return $RGB;
	}
}



class cal
{

	public $data;
	public $t_day;
	public $nav;
	public $fontcolor;

	function __construct ($data, $t_day, $nav, $mon, $tue, $wed, $thu, $fri, $sat, $sun, $firstday, $bgcolor, $bgimage, $bgimagerepeat, $na,$nb,$nc,$nd,$ne,$nf,$ng)
	{
		$this->data=$data;
		$this->t_day=$t_day;
		$this->nav=$nav;
		$this->mon=$mon;
		$this->tue=$tue;
		$this->wed=$wed;
		$this->thu=$thu;
		$this->fri=$fri;
		$this->sat=$sat;
		$this->sun=$sun;
		$this->na=$na;
		$this->nb=$nb;
		$this->nc=$nc;
		$this->nd=$nd;
		$this->ne=$ne;
		$this->nf=$nf;
		$this->ng=$ng;
		$this->firstday=$firstday;
		$this->bgcolor=$bgcolor;
		$this->bgimage=$bgimage;
		$this->bgimagerepeat=$bgimagerepeat;
		
		
	}
		
	function days ()
	{

	echo '<div class="iccalendar" style="background-color: '.$this->bgcolor.'; background-image: url(\''.$this->bgimage.'\'); background-repeat: '.$this->bgimagerepeat.'">';


		if ($this->firstday=='0') {
			echo '<div id="mod_iccalendar">'.$this->nav.'
			<table id="icagenda_calendar" width="100%" cellspacing="0">
				<thead>
					<th width="15%" style="background:'.$this->sun.';">'.JText::_('SUN').'</th>
					<th width="14%" style="background:'.$this->mon.';">'.JText::_('MON').'</th>
					<th width="14%" style="background:'.$this->tue.';">'.JText::_('TUE').'</th>
					<th width="14%" style="background:'.$this->wed.';">'.JText::_('WED').'</th>
					<th width="14%" style="background:'.$this->thu.';">'.JText::_('THU').'</th>
					<th width="14%" style="background:'.$this->fri.';">'.JText::_('FRI').'</th>
					<th width="15%" style="background:'.$this->sat.';">'.JText::_('SAT').'</th>
				</thead>
		';
		}
		if ($this->firstday=='1') {
			echo '<div id="mod_iccalendar">'.$this->nav.'
			<table id="icagenda_calendar" width="100%" cellspacing="0">
				<thead>
					<th width="15%" style="background:'.$this->mon.';">'.JText::_('MON').'</th>
					<th width="14%" style="background:'.$this->tue.';">'.JText::_('TUE').'</th>
					<th width="14%" style="background:'.$this->wed.';">'.JText::_('WED').'</th>
					<th width="14%" style="background:'.$this->thu.';">'.JText::_('THU').'</th>
					<th width="14%" style="background:'.$this->fri.';">'.JText::_('FRI').'</th>
					<th width="14%" style="background:'.$this->sat.';">'.JText::_('SAT').'</th>
					<th width="15%" style="background:'.$this->sun.';">'.JText::_('SUN').'</th>
				</thead>
		';
		}
		
		switch ($this->data[1]['week']){
			case $this->na:
				break;
			default:
				echo '<tr><td colspan="'.($this->data[1]['week']-$this->firstday).'"></td>';
				break;		
		}
		
		foreach ($this->data as $d){
			$stamp= new day($d);
			
		if ($this->firstday=='0') {
			switch($stamp->week){
				case $this->na:
					echo '<tr><td style="background:'.$this->sun.';">';
					break;
				case $this->nb:
					echo '<td style="background:'.$this->mon.';">';
					break;
				case $this->nc:
					echo '<td style="background:'.$this->tue.';">';
					break;
				case $this->nd:
					echo '<td style="background:'.$this->wed.';">';
					break;
				case $this->ne:
					echo '<td style="background:'.$this->thu.';">';
					break;
				case $this->nf:
					echo '<td style="background:'.$this->fri.';">';
					break;
				case $this->ng:
					echo '<td style="background:'.$this->sat.';">';
					break;
				default:
					echo '<td>';
					break;
			}
		}
			
		if ($this->firstday=='1') {
			switch($stamp->week){
				case $this->na:
					echo '<tr><td style="background:'.$this->mon.';">';
					break;
				case $this->nb:
					echo '<td style="background:'.$this->tue.';">';
					break;
				case $this->nc:
					echo '<td style="background:'.$this->wed.';">';
					break;
				case $this->nd:
					echo '<td style="background:'.$this->thu.';">';
					break;
				case $this->ne:
					echo '<td style="background:'.$this->fri.';">';
					break;
				case $this->nf:
					echo '<td style="background:'.$this->sat.';">';
					break;
				case $this->ng:
					echo '<td style="background:'.$this->sun.';">';
					break;
				default:
					echo '<td>';
					break;
			}
		}
//			rsort($stamp->events);
//			$RGB = '$RGB';
			$bgcolor ='';
			if (isset($stamp->events[0]['cat_color'])) { $RGB = explode(",",activeColor($stamp->events[0]['cat_color']));
			$c = array($RGB[0], $RGB[1], $RGB[2]);
			$bgcolor = array_sum($c);				
			 }
			if ($bgcolor > '600') {
				$bgcolor='bright';
			} else {
				$bgcolor='';
			}
			$order='first';
			if (isset($stamp->events[0]['cat_color'])) { $bg_catcolor = $stamp->events[0]['cat_color']; $bg_day=$bg_catcolor; }
			if (!isset($stamp->events[0]['cat_color'])) { $bg_day=''; }
			
			if (isset($stamp->events[1]['cat_color'])) { $multi_events = 'icmulti'; } else { $multi_events = ''; }

			require $this->t_day;
			
			switch('week'){
				case $this->ng:
					echo '</td></tr>';
					break;
				default:
					echo '</td>';
					break;
			}
		}
		
		switch ($stamp->week){
			case $this->ng:
				break;
			default:
				echo '<td colspan="'.(7-$stamp->week).'"></td></tr>';
				break;		
		}
		
		echo '</table></div>';
		
	echo '</div>';
		
	}

}

class day
{
	public $date;
	public $week;
	public $day;
	public $month;
	public $year;
	public $events;
	public $fontcolor;
	
	function __construct ($day)
	{
		foreach ($day as $k=>$v){
			$this->$k=$v;
		}
	}
}
?>